xfs
[Top] [All Lists]

[PATCH v4 7/10] xfstest: shared/003: Multi collapse range tests

To: viro@xxxxxxxxxxxxxxxxxx, david@xxxxxxxxxxxxx, bpm@xxxxxxx, tytso@xxxxxxx, adilger.kernel@xxxxxxxxx, jack@xxxxxxx
Subject: [PATCH v4 7/10] xfstest: shared/003: Multi collapse range tests
From: Namjae Jeon <linkinjeon@xxxxxxxxx>
Date: Sun, 8 Dec 2013 23:12:31 +0900
Cc: linux-fsdevel@xxxxxxxxxxxxxxx, xfs@xxxxxxxxxxx, linux-ext4@xxxxxxxxxxxxxxx, linux-kernel@xxxxxxxxxxxxxxx, Namjae Jeon <linkinjeon@xxxxxxxxx>, Namjae Jeon <namjae.jeon@xxxxxxxxxxx>, Ashish Sangwan <a.sangwan@xxxxxxxxxxx>
Delivered-to: xfs@xxxxxxxxxxx
Dkim-signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113; h=from:to:cc:subject:date:message-id; bh=p6/QRFXxV1TGXUsc/JGu7uMwqO0buiW8zlRkKBwVMU4=; b=IUWHgRQnK9F419N/2O4vz6ZoHBHx5U3404wVgF5Of2OaCMoUDzxItLNPy7IMK9HpvV 2P030XN7Pofnj9DUYPTDkhBBQGuj1TcjKdW3xEcOgqG7vkEk8vsLhTyjvig5y94kV4Kd /kahEB6TtQkmp8k0b0D1P8JXaWarDcTUeeXQS/PqMt5wl+IQVbCB8Xe792O3M09KHiEr YC+BP/xbf0U5OgDR+lco0ljOqaCmZnYCOLp9Jo7JBSpRdH+N8dfxKNs26wqJQHbQRZ1G aVM1Wv2P4qVVXdftlB/1HCDk6p29SUQu/88MEHewhiqH0zIp4lBQmAOnwzjdS/eI6So2 fmcQ==
From: Namjae Jeon <namjae.jeon@xxxxxxxxxxx>

This testcase(003) tries to test various corner cases with pre-existing holes
for fcollapse range functionality over different type of extents.

Signed-off-by: Namjae Jeon <namjae.jeon@xxxxxxxxxxx>
Signed-off-by: Ashish Sangwan <a.sangwan@xxxxxxxxxxx>
---
 tests/shared/003     |   65 ++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/shared/003.out |   53 ++++++++++++++++++++++++++++++++++++++++
 tests/shared/group   |    1 +
 3 files changed, 119 insertions(+)
 create mode 100755 tests/shared/003
 create mode 100644 tests/shared/003.out

diff --git a/tests/shared/003 b/tests/shared/003
new file mode 100755
index 0000000..7b7f2df
--- /dev/null
+++ b/tests/shared/003
@@ -0,0 +1,65 @@
+#! /bin/bash
+# FS QA Test No. 3
+#
+# Multi collapse range tests
+# This testcase is one of the 4 testcases (shared 001 - 004) which tries to
+# test various corner cases for fcollapse range functionality over different
+# type of extents. These tests are based on generic/255 test case.
+# For the type of tests, check the description of _test_generic_punch
+# in common/rc.
+#-----------------------------------------------------------------------
+# Copyright (c) 2013 Samsung Electronics.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1       # failure is the default!
+
+_cleanup()
+{
+    rm -f $tmp.*
+}
+
+trap "_cleanup ; exit \$status" 0 1 2 3 15
+
+# get standard environment, filters and checks
+# we need to include common/punch to get defination fo filter functions
+. ./common/rc
+. ./common/filter
+. ./common/punch
+
+# real QA test starts here
+_supported_fs xfs ext4
+_supported_os Linux
+
+_require_xfs_io_falloc_punch
+_require_xfs_io_falloc
+_require_xfs_io_fiemap
+_require_xfs_io_falloc_collapse
+
+testfile=$TEST_DIR/$seq.$$
+
+_test_generic_punch -k falloc fpunch fcollapse fiemap _filter_hole_fiemap 
$testfile
+_check_test_fs
+
+status=0
+exit
diff --git a/tests/shared/003.out b/tests/shared/003.out
new file mode 100644
index 0000000..545304e
--- /dev/null
+++ b/tests/shared/003.out
@@ -0,0 +1,53 @@
+QA output created by 003
+       1. into a hole
+f4f35d60b3cc18aaa6d8d92f0cd3708a
+       2. into allocated space
+0: [0..95]: extent
+f1894a71ac539f6f90426d98a4990a47
+       3. into unwritten space
+0: [0..95]: extent
+f07217d5ac7ffa15dd8910c4aa912674
+       4. hole -> data
+0: [0..63]: extent
+1: [64..95]: hole
+e5c94f6299822646f9f57aeacd8bdc01
+       5. hole -> unwritten
+0: [0..63]: extent
+1: [64..95]: hole
+f07217d5ac7ffa15dd8910c4aa912674
+       6. data -> hole
+0: [0..31]: extent
+1: [32..95]: hole
+f07217d5ac7ffa15dd8910c4aa912674
+       7. data -> unwritten
+0: [0..63]: extent
+1: [64..95]: hole
+f07217d5ac7ffa15dd8910c4aa912674
+       8. unwritten -> hole
+0: [0..31]: extent
+1: [32..95]: hole
+f07217d5ac7ffa15dd8910c4aa912674
+       9. unwritten -> data
+0: [0..63]: extent
+1: [64..95]: hole
+e5c94f6299822646f9f57aeacd8bdc01
+       10. hole -> data -> hole
+0: [0..31]: extent
+1: [32..63]: hole
+76cc863b386460b228a493933813a6a0
+       11. data -> hole -> data
+0: [0..63]: extent
+0f0151cbed83e4bf6e5bde26e82ab115
+       12. unwritten -> data -> unwritten
+0: [0..63]: extent
+76cc863b386460b228a493933813a6a0
+       13. data -> unwritten -> data
+0: [0..63]: extent
+0f0151cbed83e4bf6e5bde26e82ab115
+       14. data -> hole @ EOF
+fallocate: Invalid argument
+0: [0..159]: extent
+7670f4830c6724a25e7c22d9eb9a6f4f
+       15. data -> hole @ 0
+0: [0..95]: extent
+f1894a71ac539f6f90426d98a4990a47
diff --git a/tests/shared/group b/tests/shared/group
index 7230b28..9226032 100644
--- a/tests/shared/group
+++ b/tests/shared/group
@@ -5,6 +5,7 @@
 #
 001 auto prealloc
 002 auto prealloc
+003 auto prealloc
 032 mkfs auto quick
 051 acl udf auto quick
 218 auto fsr quick
-- 
1.7.9.5

<Prev in Thread] Current Thread [Next in Thread>